
const  defaultEnvName = "ar";

export default class Environment {




    constructor(options = {}) {
        this.name = options.name ? options.name : defaultEnvName;
        this.defaultOptions = {
            paragraphs: {
                T1: true,
                T2: true,
                T3: true,
                T4: true,
                quote : true
            },

            characters : {}
        }

        this.setOptions({
            ...this.defaultOptions,
            ...options,
        })
    }


    setOptions(options) {
        this.options = {
            ...this.options,
            ...options,
        }

    }


    hasParagraphOption(optionKey){
        return this.options.paragraphs[optionKey] | false;
    }

    hasCharOption(optionKey){
        return this.options.characters[optionKey] | false;
    }


    static async loadEnvironment(envName) {
        if(envName === defaultEnvName)
            return new Environment();
        else
            return Environment.loadEnvironmentFromJSONFile('/env/' + envName + '.json')

    }

    static async loadEnvironmentFromJSONFile(filePath) {
        let res = await fetch(filePath);
        let json = await res.json();
        return Environment.loadEnvironmentFromJSON(json);


    }

    static loadEnvironmentFromJSON(json) {
        return new Environment(json);
    }

}
